package com.sibatel.solarapp.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.sibatel.solarapp.data.model.mobil.Mobil
import com.sibatel.solarapp.databinding.ListMobilBinding

class MobilAdapter(var listMobil : ArrayList<Mobil>?) : RecyclerView.Adapter<MobilAdapter.MobilViewHolder>(){

    inner class MobilViewHolder(private val binding: ListMobilBinding) : RecyclerView.ViewHolder(binding.root){
            val jenis = binding.mobilJenis
            val nama = binding.mobilNama
            val status = binding.mobilStatus

    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MobilViewHolder {
        val view = ListMobilBinding.inflate(LayoutInflater.from(parent.context), parent,false)
        return MobilViewHolder(view)
    }

    override fun onBindViewHolder(holder: MobilViewHolder, position: Int) {
        holder.nama.text = listMobil?.get(position)?.namaUser
        holder.jenis.text = listMobil?.get(position)?.role
        val sts = listMobil?.get(position)?.status
        var tujuanSite = listMobil?.get(position)?.tujuanSite
        if (tujuanSite == null){
            tujuanSite = listMobil?.get(position)?.tujuanPengambilan
        }

        if (sts == "Sedang Berjalan"){
            holder.status.text = sts+" ke "+tujuanSite
        }else{
            holder.status.text = "Standby"
        }

    }

    override fun getItemCount(): Int {
        return listMobil?.size ?: 0
    }
}