package com.sibatel.solarapp.data

import androidx.lifecycle.LiveData
import com.sibatel.solarapp.data.model.mobil.Mobil
import com.sibatel.solarapp.data.model.solar.pengambilansolar.PengambilanSolar
import com.sibatel.solarapp.data.model.solar.penggunaansolar.PenggunaanSolar
import com.sibatel.solarapp.data.model.tower.Maintenance
import com.sibatel.solarapp.data.model.user.User

interface SolarDataSource {
    fun getMobilList() : LiveData<ArrayList<Mobil>>

    fun getUserList() : LiveData<ArrayList<User>>

    fun getPengambilanSolarList(id:Int) : LiveData<ArrayList<PengambilanSolar>>

    fun getPenggunaanSolarList(id: Int) : LiveData<ArrayList<PenggunaanSolar>>

    fun getMaintenanceList(id: Int) : LiveData<ArrayList<Maintenance>>
}