package com.sibatel.solarapp.network

import com.sibatel.solarapp.data.model.genset.GensetResponse
import com.sibatel.solarapp.data.model.keuangan.BiayaLapanganResponse
import com.sibatel.solarapp.data.model.mobil.MobilResponse
import com.sibatel.solarapp.data.model.solar.pengambilansolar.PengambilanSolarResponse
import com.sibatel.solarapp.data.model.solar.penggunaansolar.PenggunaanSolarResponse
import com.sibatel.solarapp.data.model.tower.MaintenanceResponse
import com.sibatel.solarapp.data.model.tower.TowerResponse
import com.sibatel.solarapp.data.model.user.LoginResponse
import com.sibatel.solarapp.data.model.user.UserResponse
import okhttp3.MultipartBody
import okhttp3.RequestBody
import retrofit2.Call
import retrofit2.http.*


interface ApiServices {
    @FormUrlEncoded
    @POST("postlogin")
    fun login(
        @Field("no_hp") noHp : String,
        @Field("password") password : String
        ) : Call<LoginResponse>


    //mobil
    @GET("mobil")
    fun getMobileData():Call<MobilResponse>

    @FormUrlEncoded
    @POST("batalkan_orderan")
    fun batalkanPesanan(
        @Field("userId")userId : String
    ):Call<MobilResponse>

    @FormUrlEncoded
    @POST("order")
    fun orderMobil(
        @Field("userId")userId : String,
        @Field("tanggal") tanggal: String,
        @Field("tujuan_site") tujuan_site : String,
    ):Call<MobilResponse>

    @GET("user")
    fun getAllUser():Call<UserResponse>

    @Multipart
    @POST("pengambilan_solar")
    fun addPengambilanSolar(@Part gbr_sp_sblm : MultipartBody.Part?,
                            @Part gbr_sp_sdh : MultipartBody.Part?,
                            @Part gbr_gs_sblm : MultipartBody.Part?,
                            @Part gbr_gs_sdh : MultipartBody.Part?,
                            @PartMap  text :Map<String, @JvmSuppressWildcards RequestBody>
    ) : Call<PengambilanSolarResponse>

    @Multipart
    @POST("postUpdatePengambilanSolar")
    fun updatePengambilanSolar(@Part gbr_gs_sblm : MultipartBody.Part?,
                            @Part gbr_gs_sdh : MultipartBody.Part?,
                            @PartMap  text :Map<String, @JvmSuppressWildcards RequestBody>
    ) : Call<PengambilanSolarResponse>


    @GET("pengambilan_solar")
    fun getAllPengambilanSolar(
        @Query("id") id: Int
    ): Call<PengambilanSolarResponse>



    @GET("penggunaan_solar")
    fun getAllPenggunaanSolar(
        @Query("id") id: Int
    ): Call<PenggunaanSolarResponse>

    @Multipart
    @POST("penggunaan_solar")
    fun addPenggunaanSolar(@Part gbr_hmakhir: MultipartBody.Part?,
                           @PartMap text: Map<String, @JvmSuppressWildcards RequestBody>
    ) : Call<PenggunaanSolarResponse>

    @GET("cekPenggunaanSolar")
    fun cekPenggunaanSolar(
        @Query("id") id: Int
    ): Call<PenggunaanSolarResponse>


    @FormUrlEncoded
    @POST("dafarPengambilanSolar")
    fun dafarPengambilanSolar( @Field("site")site:String) : Call<PengambilanSolarResponse>

    @GET("tower")
    fun getAllTower(): Call<TowerResponse>

    @GET("allPendonorSite")
    fun getAllPendonorSite(): Call<TowerResponse>


    @GET("cekPengambilanSolar")
    fun cekPengambilanSolar(
        @Query("id") id: Int
    ): Call<PengambilanSolarResponse>

    @FormUrlEncoded
    @POST("updatePenggunaanSolar")
    fun updatePenggunaanSolar(
        @Field("user_id")user_id:String,
        @Field("tanggal")tanggal:String,
        @Field("tujuan_site")tujuan_site:String) : Call<PenggunaanSolarResponse>



    @Multipart
    @POST("addBiayaLapangan")
    fun addBiayaLapangan(
        @Part gbr_sblm : MultipartBody.Part?,
        @Part gbr_sdh : MultipartBody.Part?,
        @Part gbr_bon : MultipartBody.Part?,
        @Part gbr_lapangan : MultipartBody.Part?,
        @PartMap  text :Map<String, @JvmSuppressWildcards RequestBody>
    ):Call<BiayaLapanganResponse>


    @GET("genset")
    fun getAllGenset():Call<GensetResponse>

    @GET("maintenance")
    fun getAllMaintenance(
        @Query("id") id: Int
    ):Call<MaintenanceResponse>

    @FormUrlEncoded
    @POST("tambahMaintenance")
    fun tambahMaintenance(
        @Field("id") id : String,
        @Field("tanggal") tanggal : String,
        @Field("tujuan_site") tujuan_site : String
    ) : Call<MaintenanceResponse>
}
