package com.sibatel.solarapp.ui


import android.Manifest
import android.app.AlertDialog
import android.content.Context
import android.content.DialogInterface
import android.content.Intent
import android.content.pm.PackageManager
import android.net.ConnectivityManager
import android.os.Build
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Button
import android.widget.EditText
import android.widget.ProgressBar
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.core.app.ActivityCompat
import androidx.core.content.ContextCompat
import com.sibatel.solarapp.R
import com.sibatel.solarapp.data.model.user.LoginResponse
import com.sibatel.solarapp.network.RetrofitClient
import com.sibatel.solarapp.utils.SharedPref
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response


class   LoginActivity : AppCompatActivity() {
    private lateinit var button: Button
    private lateinit var sharedPreferences: SharedPref
    private lateinit var progressBar : ProgressBar

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_login)
        progressBar = findViewById(R.id.progress)
        showLoading(false)

        sharedPreferences = SharedPref(this)
        if (sharedPreferences.getStatusLogin()){
            val intent = Intent(this, MainActivity::class.java)
            finish()
            startActivity(intent)
        }
        val noHp = findViewById<EditText>(R.id.textInputHp).text
        val password = findViewById<EditText>(R.id.textInputPass).text
        button = findViewById(R.id.cirLoginButton)
        button.setOnClickListener{
            showLoading(true)
            login(noHp.toString(), password.toString())
        }
    }

    fun login(noHp:String, password:String){
        RetrofitClient.apiInstance.login(noHp, password)
            .enqueue(object : Callback<LoginResponse>{
                    override fun onResponse(
                        call: Call<LoginResponse>,
                        response: Response<LoginResponse>
                    ) {
                        if (isConnect()){
                            if (response.isSuccessful){
                                 if (response.body()?.success=="1"){
                                     sharedPreferences.setStatusLogin(true)
                                     sharedPreferences.setId(response.body()?.results?.id)
                                     sharedPreferences.setNama(response.body()?.results?.nama)
                                     sharedPreferences.setRole(response.body()?.results?.role)
                                     sharedPreferences.setSite(response.body()?.results?.cluster)
                                     Toast.makeText(getApplicationContext(), response.body()?.message, Toast.LENGTH_LONG).show()
                                     showLoading(false)
                                     val intent = Intent(this@LoginActivity, MainActivity::class.java)
                                     startActivity(intent)
                                     finish()
                                }else{
                                    showLoading(false)
                                    Toast.makeText(getApplicationContext(), "No Hp / Password salah!", Toast.LENGTH_LONG).show()
                                }
                            }else{
                                showLoading(false)
                                Toast.makeText(getApplicationContext(), response.message() ,
                                    Toast.LENGTH_LONG).show()
                            }
                        }else{
                            showLoading(false)
                            Toast.makeText(getApplicationContext(), "Device tidak terhubung ke INTERNET", Toast.LENGTH_LONG).show()
                        }

                    }

                    override fun onFailure(call: Call<LoginResponse>, t: Throwable) {
                        showLoading(false)
                        t.message?.let { Log.d("error Server", it)
                    }
                }
            })
    }

    @Suppress("DEPRECATION")
    fun isConnect():Boolean{
        val connect : ConnectivityManager = getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager
        return connect.activeNetworkInfo!!.isConnected
    }

    private fun showLoading(state: Boolean) {
        if (state)
            progressBar.visibility = View.VISIBLE
        else
            progressBar.visibility = View.GONE
    }



}