package com.sibatel.solarapp.ui.keuangan

import android.app.AlertDialog
import android.app.DatePickerDialog
import android.content.DialogInterface
import android.content.Intent
import android.database.Cursor
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.os.Bundle
import android.os.Environment
import android.provider.MediaStore
import android.text.Editable
import android.util.Base64
import android.util.Log
import android.view.View
import android.widget.AdapterView
import android.widget.ArrayAdapter
import android.widget.Toast
import androidx.annotation.NonNull
import androidx.appcompat.app.AppCompatActivity
import androidx.core.content.FileProvider
import com.sibatel.solarapp.R
import com.sibatel.solarapp.data.model.keuangan.BiayaLapanganResponse
import com.sibatel.solarapp.databinding.ActivityBiayaLapanganBinding
import com.sibatel.solarapp.network.RetrofitClient
import com.sibatel.solarapp.ui.MainActivity
import com.sibatel.solarapp.utils.SharedPref
import okhttp3.MediaType
import okhttp3.MultipartBody
import okhttp3.RequestBody
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.io.*
import java.util.*

class Keuangan : AppCompatActivity(){
    private lateinit var binding : ActivityBiayaLapanganBinding
    private lateinit var sharedPref: SharedPref
    private var Document_img1: String = ""
    private lateinit var bitmap1 : Bitmap
    private lateinit var bitmap2 : Bitmap
    private lateinit var bitmap3 : Bitmap
    private lateinit var bitmap4 : Bitmap
    var img1 =""
    var img2 =""
    var img3 =""
    var img4 =""
    private var cekUp: Int = 0
    var tanggal = ""

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityBiayaLapanganBinding.inflate(layoutInflater)
        setContentView(binding.root)

        supportActionBar?.elevation = 0f
        supportActionBar?.setDisplayHomeAsUpEnabled(true)
        supportActionBar?.title = "Keuangan"

        binding.dateSolarTaken.setOnClickListener {
            val cldr: Calendar = Calendar.getInstance()
            val day: Int = cldr.get(Calendar.DAY_OF_MONTH)
            val month: Int = cldr.get(Calendar.MONTH)
            val year: Int = cldr.get(Calendar.YEAR)

            val picker = DatePickerDialog(
                this,
                DatePickerDialog.OnDateSetListener { view, year, monthOfYear, dayOfMonth ->
                    binding.dateSolarTaken.setText(
                        year.toString() + "/" + (monthOfYear + 1) + "/" + dayOfMonth.toString()
                    )
                    tanggal = binding.dateSolarTaken.text.toString()
                },
                year,
                month,
                day
            )
            picker.show()
        }


        sharedPref = SharedPref(this)

        binding.txtHarga.visibility = View.GONE
        binding.harga.visibility = View.GONE
        binding.txtJumlahLiter.visibility = View.GONE
        binding.jumlahLiter.visibility = View.GONE
        binding.txtNamaSite.visibility = View.GONE
        binding.namaSite.visibility = View.GONE
        binding.txtGenset.visibility = View.GONE
        binding.genset.visibility = View.GONE
        binding.txtNamaBarang.visibility = View.GONE
        binding.namaBarang.visibility = View.GONE
        binding.txtJumlahUnit.visibility = View.GONE
        binding.jumlahUnit.visibility = View.GONE
        binding.txtKeterangan.visibility = View.GONE
        binding.keterangan.visibility = View.GONE
        binding.txtTujuanPengiriman.visibility = View.GONE
        binding.tujuanPengiriman.visibility = View.GONE
        binding.txtKetTagihan.visibility = View.GONE
        binding.ketTagihan.visibility = View.GONE
        binding.txtNamaPenjagaSite.visibility = View.GONE
        binding.namaPenjagaSite.visibility = View.GONE
        binding.txtBbmMobil.visibility = View.GONE
        binding.bbmMobil.visibility = View.GONE
        binding.txtUangMakan.visibility = View.GONE
        binding.uangMakan.visibility = View.GONE
        binding.txtSuratLurah.visibility = View.GONE
        binding.suratLurah.visibility = View.GONE
        binding.txtBiayaLain.visibility = View.GONE
        binding.biayaLain.visibility = View.GONE
        binding.txtBiayaTeknis.visibility = View.GONE
        binding.biayaTeknis.visibility = View.GONE
        binding.txtBiayaBeliPerangkat.visibility = View.GONE
        binding.biayaBeliPerangkat.visibility = View.GONE
        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
        binding.biayaPerbaikanPerangkat.visibility = View.GONE
        binding.txtSiteDonor.visibility = View.GONE
        binding.siteDonor.visibility = View.GONE
        binding.txtSiteReceipter.visibility = View.GONE
        binding.siteReceipter.visibility = View.GONE
        binding.txtDanaOprasional.visibility = View.GONE
        binding.danaOprasional.visibility = View.GONE
        binding.txtBiayaTukang.visibility = View.GONE
        binding.biayaTukang.visibility = View.GONE
        binding.txtKeteranganPengiriman.visibility = View.GONE
        binding.keteranganPengiriman.visibility = View.GONE

        binding.layoutSblm.visibility = View.GONE
        binding.layoutSdh.visibility = View.GONE
        binding.layoutBon.visibility = View.GONE
        binding.layoutLapangan.visibility = View.GONE







        var kategori = ""
        val biaya = binding.harga.text
        val jumblahLiter = binding.jumlahLiter.text
        val namaSite = binding.namaSite.text
        val genset = binding.genset.text
        val namaBarang = binding.namaBarang.text
        val jlhUnit = binding.jumlahUnit.text
        val keterangan = binding.keterangan.text
        val tujuanPengiriman = binding.tujuanPengiriman.text
        val ketTagihan = binding.ketTagihan.text
        val namaPenjagaSite = binding.namaPenjagaSite.text
        val bbmMobil = binding.bbmMobil.text
        val uangMakan =  binding.uangMakan.text
        val suratLurah = binding.suratLurah.text
        val biayaLain = binding.biayaLain.text
        val biayaTeknis = binding.biayaTeknis.text
        val biayaBeliPerangkat = binding.biayaBeliPerangkat.text
        val biayaPerbaikanPerangkat = binding.biayaPerbaikanPerangkat.text
        val siteDonor = binding.siteDonor.text
        val siteReceipter = binding.siteReceipter.text
        val danaOprasional = binding.danaOprasional.text
        val biayaTukang =  binding.biayaTukang.text
        var userId = sharedPref.getId()



        var opsiKategori = ArrayList<String>()
        if (sharedPref.getRole1().equals("scd")){
            opsiKategori.add("Pilih Kategori")
            opsiKategori.add("BBM Mobil")
            opsiKategori.add("BBM Genset")
            opsiKategori.add("Beli Oli Genset")
            opsiKategori.add("Beli Sparepart")
            opsiKategori.add("Biaya Services")
            opsiKategori.add("Pembelian Lain-lain")
            opsiKategori.add("Biaya Lain-lain")
        }else if(sharedPref.getRole1().equals("timkorektif")||sharedPref.getRole1().equals("koordinator")){
            opsiKategori.add("Pilih Kategori")
            opsiKategori.add("BBM Mobil")
            opsiKategori.add("Beli Oli Genset")
            opsiKategori.add("Beli Sparepart")
            opsiKategori.add("Biaya Services")
            opsiKategori.add("Biaya Kirim Paket")
            opsiKategori.add("Pembelian Lain-lain")
            opsiKategori.add("Biaya Lain-lain")
            opsiKategori.add("Support Jasa PLN")
        }else if(sharedPref.getRole1().equals("maintenance")){
            opsiKategori.add("Pilih Kategori")
            opsiKategori.add("BBM Mobil")
            opsiKategori.add("BBM Mesin Babat")
            opsiKategori.add("Beli Oli Genset")
            opsiKategori.add("Beli Peralatan Maintenance")
            opsiKategori.add("Support Penjaga Site/Warga")
            opsiKategori.add("Beli Sparepart")
            opsiKategori.add("Pembelian Lain-lain")
            opsiKategori.add("Biaya Lain-lain")
        }else if(sharedPref.getRole1().equals("timproject")){
            opsiKategori.add("Pilih Kategori")
            opsiKategori.add("Selective Site")
            opsiKategori.add("Perkerjaan dismantle & Install Radio")
            opsiKategori.add("Pekerjaan Project Lain")
            opsiKategori.add("Biaya Lain-lain")
        }else if(sharedPref.getRole1().equals("cgl")){
            opsiKategori.add("Pilih Kategori")
            opsiKategori.add("Biaya Investigasi")
            opsiKategori.add("Biaya Eksekusi")
            opsiKategori.add("Biaya Survey")
            opsiKategori.add("Biaya Lain-lain")
        }


        val adapter = ArrayAdapter<String>(this, R.layout.support_simple_spinner_dropdown_item, opsiKategori)
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        binding.kategori.adapter = adapter

        binding.kategori.onItemSelectedListener = object : AdapterView.OnItemSelectedListener{
            override fun onItemSelected(p0: AdapterView<*>?, p1: View?, p2: Int, p3: Long) {
                if (p2 == 0){
                    kategori = ""
                }else{
                    val number = p0?.getItemAtPosition(p2).toString()
                    kategori = number

                    if (kategori.equals("BBM Mobil")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.VISIBLE
                        binding.jumlahLiter.visibility = View.VISIBLE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE
                        binding.layoutSblm.visibility = View.VISIBLE
                        binding.txtGbrSblm.text = "Foto odometer sebelum"
                        binding.layoutSdh.visibility = View.VISIBLE
                        binding.txtGbrSsdh.text = "Foto odometer sesudah"
                        binding.layoutBon.visibility = View.GONE
                        binding.layoutLapangan.visibility = View.GONE
                    }else if(kategori.equals("BBM Mesin Babat")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.VISIBLE
                        binding.jumlahLiter.visibility = View.VISIBLE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE
                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM Genset Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Bon Pembelian"
                        binding.layoutLapangan.visibility = View.VISIBLE
                    }else if(kategori.equals("BBM Genset")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.VISIBLE
                        binding.jumlahLiter.visibility = View.VISIBLE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.VISIBLE
                        binding.txtGbrSblm.text = "Foto HM Genset Sebelum"
                        binding.layoutSdh.visibility = View.VISIBLE
                        binding.txtGbrSsdh.text = "Foto HM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Bon Pembelian"
                        binding.layoutLapangan.visibility = View.GONE
                    }else if(kategori.equals("Beli Oli Genset")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.VISIBLE
                        binding.jumlahLiter.visibility = View.VISIBLE
                        binding.txtNamaSite.visibility = View.VISIBLE
                        binding.namaSite.visibility = View.VISIBLE
                        binding.txtGenset.visibility = View.VISIBLE
                        binding.genset.visibility = View.VISIBLE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE
                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM Genset Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Bon Pembelian"
                        binding.layoutLapangan.visibility = View.GONE
                    }else if(kategori.equals("Beli Sparepart")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.VISIBLE
                        binding.namaSite.visibility = View.VISIBLE
                        binding.txtGenset.visibility = View.VISIBLE
                        binding.genset.visibility = View.VISIBLE
                        binding.txtNamaBarang.visibility = View.VISIBLE
                        binding.namaBarang.visibility = View.VISIBLE
                        binding.txtJumlahUnit.visibility = View.VISIBLE
                        binding.jumlahUnit.visibility = View.VISIBLE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM Genset Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Bon Pembelian"
                        binding.layoutLapangan.visibility = View.GONE
                    }else if(kategori.equals("Biaya Services")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.VISIBLE
                        binding.namaBarang.visibility = View.VISIBLE
                        binding.txtJumlahUnit.visibility = View.VISIBLE
                        binding.jumlahUnit.visibility = View.VISIBLE
                        binding.txtKeterangan.visibility = View.VISIBLE
                        binding.keterangan.visibility = View.VISIBLE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM Genset Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Bon Pembelian"
                        binding.layoutLapangan.visibility = View.GONE
                    }else if(kategori.equals("Biaya Kirim Paket")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.VISIBLE
                        binding.namaBarang.visibility = View.VISIBLE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.VISIBLE
                        binding.tujuanPengiriman.visibility = View.VISIBLE
                        binding.txtKetTagihan.visibility = View.VISIBLE
                        binding.ketTagihan.visibility = View.VISIBLE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM Genset Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Bon Pembelian"
                        binding.layoutLapangan.visibility = View.GONE
                    }else if(kategori.equals("Pembelian Lain-lain")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.VISIBLE
                        binding.namaBarang.visibility = View.VISIBLE
                        binding.txtJumlahUnit.visibility = View.VISIBLE
                        binding.jumlahUnit.visibility = View.VISIBLE
                        binding.txtKeterangan.visibility = View.VISIBLE
                        binding.keterangan.visibility = View.VISIBLE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM Genset Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Bon Pembelian"
                        binding.layoutLapangan.visibility = View.GONE
                    }else if(kategori.equals("Biaya Lain-lain")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.VISIBLE
                        binding.keterangan.visibility = View.VISIBLE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE
                    }else if(kategori.equals("Support Jasa PLN")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.VISIBLE
                        binding.namaSite.visibility = View.VISIBLE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.VISIBLE
                        binding.keterangan.visibility = View.VISIBLE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM Genset Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Dokumentasi"
                        binding.layoutLapangan.visibility = View.GONE
                    }else if(kategori.equals("Beli Peralatan Maintenance")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.VISIBLE
                        binding.namaBarang.visibility = View.VISIBLE
                        binding.txtJumlahUnit.visibility = View.VISIBLE
                        binding.jumlahUnit.visibility = View.VISIBLE
                        binding.txtKeterangan.visibility = View.VISIBLE
                        binding.keterangan.visibility = View.VISIBLE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM Genset Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Bon Pembelian"
                        binding.layoutLapangan.visibility = View.GONE

                    }else if(kategori.equals("Support Penjaga Site/Warga")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.VISIBLE
                        binding.namaSite.visibility = View.VISIBLE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.VISIBLE
                        binding.namaPenjagaSite.visibility = View.VISIBLE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM Genset Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM Genset Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Bon Pembelian"
                        binding.layoutLapangan.visibility = View.GONE

                    }else if(kategori.equals("Perkerjaan dismantle & Install Radio")){
                        binding.txtHarga.text = "Beli Sparepart"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.VISIBLE
                        binding.namaSite.visibility = View.VISIBLE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.VISIBLE
                        binding.bbmMobil.visibility = View.VISIBLE
                        binding.txtUangMakan.visibility = View.VISIBLE
                        binding.uangMakan.visibility = View.VISIBLE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.VISIBLE
                        binding.biayaLain.visibility = View.VISIBLE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.VISIBLE
                        binding.biayaBeliPerangkat.visibility = View.VISIBLE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.VISIBLE
                        binding.biayaPerbaikanPerangkat.visibility = View.VISIBLE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.VISIBLE
                        binding.biayaTukang.visibility = View.VISIBLE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.VISIBLE
                        binding.txtGbrSblm.text = "Foto KM BBM Sebelum"
                        binding.layoutSdh.visibility = View.VISIBLE
                        binding.txtGbrSsdh.text = "Foto KM BBM Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Dokumentasi"
                        binding.layoutLapangan.visibility = View.GONE

                    }else if(kategori.equals("Pekerjaan Project Lain")){
                        binding.txtHarga.text = "Beli Sparepart"
                        binding.txtHarga.visibility = View.VISIBLE
                        binding.harga.visibility = View.VISIBLE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.VISIBLE
                        binding.namaSite.visibility = View.VISIBLE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.VISIBLE
                        binding.bbmMobil.visibility = View.VISIBLE
                        binding.txtUangMakan.visibility = View.VISIBLE
                        binding.uangMakan.visibility = View.VISIBLE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.VISIBLE
                        binding.biayaLain.visibility = View.VISIBLE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.VISIBLE
                        binding.biayaBeliPerangkat.visibility = View.VISIBLE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.VISIBLE
                        binding.biayaPerbaikanPerangkat.visibility = View.VISIBLE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.VISIBLE
                        binding.biayaTukang.visibility = View.VISIBLE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.VISIBLE
                        binding.txtGbrSblm.text = "Foto KM BBM Sebelum"
                        binding.layoutSdh.visibility = View.VISIBLE
                        binding.txtGbrSsdh.text = "Foto KM BBM Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Dokumentasi"
                        binding.layoutLapangan.visibility = View.GONE

                    }else if(kategori.equals("Selective Site")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.GONE
                        binding.harga.visibility = View.GONE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.GONE
                        binding.bbmMobil.visibility = View.GONE
                        binding.txtUangMakan.visibility = View.GONE
                        binding.uangMakan.visibility = View.GONE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.VISIBLE
                        binding.siteDonor.visibility = View.VISIBLE
                        binding.txtSiteReceipter.visibility = View.VISIBLE
                        binding.siteReceipter.visibility = View.VISIBLE
                        binding.txtDanaOprasional.visibility = View.VISIBLE
                        binding.danaOprasional.visibility = View.VISIBLE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM BBM Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM BBM Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.txtGbrBon.text = "Foto Dokumentasi"
                        binding.layoutLapangan.visibility = View.GONE

                    }else if(kategori.equals("Biaya Investigasi")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.GONE
                        binding.harga.visibility = View.GONE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.VISIBLE
                        binding.bbmMobil.visibility = View.VISIBLE
                        binding.txtUangMakan.visibility = View.VISIBLE
                        binding.uangMakan.visibility = View.VISIBLE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.GONE
                        binding.biayaLain.visibility = View.GONE
                        binding.txtBiayaTeknis.visibility = View.VISIBLE
                        binding.biayaTeknis.visibility = View.VISIBLE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM BBM Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM BBM Sesudah"
                        binding.layoutBon.visibility = View.GONE
                        binding.layoutLapangan.visibility = View.VISIBLE

                    }else if(kategori.equals("Biaya Eksekusi")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.GONE
                        binding.harga.visibility = View.GONE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.VISIBLE
                        binding.bbmMobil.visibility = View.VISIBLE
                        binding.txtUangMakan.visibility = View.VISIBLE
                        binding.uangMakan.visibility = View.VISIBLE
                        binding.txtSuratLurah.visibility = View.GONE
                        binding.suratLurah.visibility = View.GONE
                        binding.txtBiayaLain.visibility = View.VISIBLE
                        binding.biayaLain.visibility = View.VISIBLE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.VISIBLE
                        binding.biayaBeliPerangkat.visibility = View.VISIBLE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.VISIBLE
                        binding.biayaPerbaikanPerangkat.visibility = View.VISIBLE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM BBM Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM BBM Sesudah"
                        binding.layoutBon.visibility = View.GONE
                        binding.layoutLapangan.visibility = View.VISIBLE

                    }else if(kategori.equals("Biaya Survey")){
                        binding.txtHarga.text = "Harga (Rp. )"
                        binding.txtHarga.visibility = View.GONE
                        binding.harga.visibility = View.GONE
                        binding.txtJumlahLiter.visibility = View.GONE
                        binding.jumlahLiter.visibility = View.GONE
                        binding.txtNamaSite.visibility = View.GONE
                        binding.namaSite.visibility = View.GONE
                        binding.txtGenset.visibility = View.GONE
                        binding.genset.visibility = View.GONE
                        binding.txtNamaBarang.visibility = View.GONE
                        binding.namaBarang.visibility = View.GONE
                        binding.txtJumlahUnit.visibility = View.GONE
                        binding.jumlahUnit.visibility = View.GONE
                        binding.txtKeterangan.visibility = View.GONE
                        binding.keterangan.visibility = View.GONE
                        binding.txtTujuanPengiriman.visibility = View.GONE
                        binding.tujuanPengiriman.visibility = View.GONE
                        binding.txtKetTagihan.visibility = View.GONE
                        binding.ketTagihan.visibility = View.GONE
                        binding.txtNamaPenjagaSite.visibility = View.GONE
                        binding.namaPenjagaSite.visibility = View.GONE
                        binding.txtBbmMobil.visibility = View.VISIBLE
                        binding.bbmMobil.visibility = View.VISIBLE
                        binding.txtUangMakan.visibility = View.VISIBLE
                        binding.uangMakan.visibility = View.VISIBLE
                        binding.txtSuratLurah.visibility = View.VISIBLE
                        binding.suratLurah.visibility = View.VISIBLE
                        binding.txtBiayaLain.visibility = View.VISIBLE
                        binding.biayaLain.visibility = View.VISIBLE
                        binding.txtBiayaTeknis.visibility = View.GONE
                        binding.biayaTeknis.visibility = View.GONE
                        binding.txtBiayaBeliPerangkat.visibility = View.GONE
                        binding.biayaBeliPerangkat.visibility = View.GONE
                        binding.txtBiayaPerbaikanPerangkat.visibility = View.GONE
                        binding.biayaPerbaikanPerangkat.visibility = View.GONE
                        binding.txtSiteDonor.visibility = View.GONE
                        binding.siteDonor.visibility = View.GONE
                        binding.txtSiteReceipter.visibility = View.GONE
                        binding.siteReceipter.visibility = View.GONE
                        binding.txtDanaOprasional.visibility = View.GONE
                        binding.danaOprasional.visibility = View.GONE
                        binding.txtBiayaTukang.visibility = View.GONE
                        binding.biayaTukang.visibility = View.GONE
                        binding.txtKeteranganPengiriman.visibility = View.GONE
                        binding.keteranganPengiriman.visibility = View.GONE

                        binding.layoutSblm.visibility = View.GONE
                        binding.txtGbrSblm.text = "Foto KM BBM Sebelum"
                        binding.layoutSdh.visibility = View.GONE
                        binding.txtGbrSsdh.text = "Foto KM BBM Sesudah"
                        binding.layoutBon.visibility = View.VISIBLE
                        binding.layoutLapangan.visibility = View.VISIBLE
                    }

                }
            }

            override fun onNothingSelected(p0: AdapterView<*>?) {

            }

        }


        binding.btnKirim.setOnClickListener{
            binding.btnKirim.startAnimation()
            kirim(tanggal, kategori, biaya.toString(), jumblahLiter.toString(), namaSite.toString(),
                genset.toString(), namaBarang.toString(),jlhUnit.toString(), keterangan.toString(),
                tujuanPengiriman.toString(), ketTagihan.toString(), namaPenjagaSite.toString(),
                bbmMobil.toString(), uangMakan.toString(), suratLurah.toString(), biayaLain.toString(),
                biayaTeknis.toString(), biayaBeliPerangkat.toString(),biayaPerbaikanPerangkat.toString(),
                siteDonor.toString(), siteReceipter.toString(), danaOprasional.toString(), biayaTukang.toString(), userId.toString())
        }



        binding.gbrSblm.setOnClickListener{
            cekUp = 1
            selectImage()
        }

        binding.gbrSdh.setOnClickListener{
            cekUp = 2
            selectImage()
        }

        binding.gbrBon.setOnClickListener{
            cekUp = 3
            selectImage()
        }

        binding.gbrLapangan.setOnClickListener{
            cekUp = 4
            selectImage()
        }
    }

    private fun selectImage() {
        val options = arrayOf<CharSequence>("Take Photo", "Choose from Gallery", "Cancel")
        val builder = AlertDialog.Builder(this)
        builder.setTitle("Add Photo!")
        builder.setItems(options, DialogInterface.OnClickListener { dialog, item ->
            if (options[item] == "Take Photo") {
                val intent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
                val f = File(Environment.getExternalStorageDirectory(), "temp.jpg")
                intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                val photoURI =  FileProvider.getUriForFile(this, this.getApplicationContext().getPackageName() + ".provider", f)
                intent.putExtra(MediaStore.EXTRA_OUTPUT, photoURI)
                startActivityForResult(intent, 1)
            } else if (options[item] == "Choose from Gallery") {
                val intent =
                    Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI)
                startActivityForResult(intent, 2)
            } else if (options[item] == "Cancel") {
                dialog.dismiss()
            }
        })
        builder.show()
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == RESULT_OK){
            if (requestCode == 1){
                var f = File(Environment.getExternalStorageDirectory().toString())
                for (temp in f.listFiles()) {
                    if (temp.name == "temp.jpg") {
                        f = temp
                        break
                    }
                }
                try {
                    val bitmapOptions = BitmapFactory.Options()
                    when (cekUp) {
                        1 -> {
                            bitmap1 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                            bitmap1 = getResizedBitmap(bitmap1, 400)
                            binding.imgGbrSblm.setImageBitmap(bitmap1)
                            BitMapToString(bitmap1)
                        }
                        2 -> {
                            bitmap2 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                            bitmap2 = getResizedBitmap(bitmap2, 400)
                            binding.imgGbrSdh.setImageBitmap(bitmap2)
                            BitMapToString(bitmap2)
                        }
                        3 -> {
                            bitmap3 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                            bitmap3 = getResizedBitmap(bitmap3, 400)
                            binding.imgGbrBon.setImageBitmap(bitmap3)
                        }
                        4 -> {
                            bitmap4 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                            bitmap4 = getResizedBitmap(bitmap4, 400)
                            binding.imgGbrLapangan.setImageBitmap(bitmap4)
                        }
                    }


                    val path = (Environment
                        .getExternalStorageDirectory()
                        .toString() + File.separator
                            + "Phoenix" + File.separator + "default")
                    f.delete()
                    var outFile: OutputStream? = null
                    val file = File(path, System.currentTimeMillis().toString() + ".jpg")
                    when (cekUp) {
                        1 -> {
                            binding.gbrSblm.text = file.name.toString().toEditable()
                            img1 = binding.gbrSblm.text.toString()
                        }
                        2 -> {
                            binding.gbrSdh.text = file.name.toString().toEditable()
                            img2 = binding.gbrSdh.text.toString()
                        }
                        3 -> {
                            binding.gbrBon.text = file.name.toString().toEditable()
                            img3 = binding.gbrBon.text.toString()
                        }
                        4 -> {
                            binding.gbrLapangan.text = file.name.toString().toEditable()
                            img4 = binding.gbrLapangan.text.toString()
                        }
                    }
                    try {
                        outFile = FileOutputStream(file)
                        when (cekUp) {
                            1 -> {
                                bitmap1.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                            }
                            2 -> {
                                bitmap2.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                            }
                            3 -> {
                                bitmap3.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                            }
                            4 -> {
                                bitmap4.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                            }
                        }
                        outFile.flush()
                        outFile.close()
                    } catch (e: FileNotFoundException) {
                        e.printStackTrace()
                    } catch (e: IOException) {
                        e.printStackTrace()
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                }catch (e: Exception) {
                    e.printStackTrace()
                }
            }else if (requestCode == 2) {
                val selectedImage = data?.data
                val filePathColumn = arrayOf(MediaStore.Images.Media.DATA)
                val cursor: Cursor? = contentResolver.query(
                    selectedImage!!,
                    filePathColumn, null, null, null
                )
                cursor?.moveToFirst()
                val columnIndex: Int = cursor!!.getColumnIndex(filePathColumn[0])
                val picturePath: String = cursor.getString(columnIndex)
                val imgNama = File(picturePath)
                try {
                    if (cekUp == 1){
                        bitmap1 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap1 = getResizedBitmap(bitmap1, 400)
                        binding.imgGbrSblm.setImageBitmap(bitmap1)
                        binding.gbrSblm.text = imgNama.name.toString().toEditable()
                        img1 = binding.gbrSblm.text.toString()
                    }else if (cekUp == 2){
                        bitmap2 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap2 = getResizedBitmap(bitmap2, 400)
                        binding.imgGbrSdh.setImageBitmap(bitmap2)
                        binding.gbrSdh.text = imgNama.name.toString().toEditable()
                        img2 = binding.gbrSdh.text.toString()
                    }else if(cekUp == 3){
                        bitmap3 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap3 = getResizedBitmap(bitmap3, 400)
                        binding.imgGbrBon.setImageBitmap(bitmap3)
                        binding.gbrBon.text = imgNama.name.toString().toEditable()
                        img3 = binding.gbrBon.text.toString()
                    }else if (cekUp == 4){
                        bitmap4 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap4 = getResizedBitmap(bitmap4, 400)
                        binding.imgGbrLapangan.setImageBitmap(bitmap4)
                        binding.gbrLapangan.text = imgNama.name.toString().toEditable()
                        img4 = binding.gbrLapangan.text.toString()
                    }
                    var outFile: OutputStream? = null
                    try{
                        outFile = FileOutputStream(imgNama)
                        if (cekUp == 1){
                            bitmap1.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                        }else if (cekUp == 2){
                            bitmap2.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                        }else if(cekUp == 3){
                            bitmap3.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                        }else if (cekUp == 4){
                            bitmap4.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                        }
                        outFile.flush()
                        outFile.close()

                    }catch (e: FileNotFoundException) {
                        e.printStackTrace()
                    } catch (e: IOException) {
                        e.printStackTrace()
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                } catch (e: IOException) {
                    e.printStackTrace()
                }

            }
        }
    }
    fun kirim(tanggal:String, kategori:String, biaya:String, jumblahLiter:String, namaSite:String, genset:String, namaBarang:String,
              jlhUnit:String,keterangan:String, tujuanPengiriman:String, ketTagihan:String, namaPenjagaSite:String,
              bbmMobil:String, uangMakan:String, suratLurah:String, biayaLain:String, biayaTeknis:String, biayaBeliPerangkat:String,
              biayaPerbaikanPerangkat:String, sitDonor:String, siteReceipter:String, danaOprasional:String, biayaTukang:String, userId:String){

        val map = HashMap<String, RequestBody>()
        map.put("tanggal", createFormatString(tanggal))
        map.put("kategori", createFormatString(kategori))
        map.put("biaya", createFormatString(biaya))
        map.put("jlh_liter", createFormatString(jumblahLiter))
        map.put("nama_site", createFormatString(namaSite))
        map.put("nama_genset", createFormatString(genset))
        map.put("nama_brg", createFormatString(namaBarang))
        map.put("jlh_unit", createFormatString(jlhUnit))
        map.put("ket_service", createFormatString(keterangan))
        map.put("tujuan_pengiriman", createFormatString(tujuanPengiriman))
        map.put("ket_tagihan", createFormatString(ketTagihan))
        map.put("nama_penjaga_site", createFormatString(namaPenjagaSite))
        map.put("bbm_mobil", createFormatString(bbmMobil))
        map.put("uang_makan", createFormatString(uangMakan))
        map.put("surat_lurah", createFormatString(suratLurah))
        map.put("biaya_lain", createFormatString(biayaLain))
        map.put("biaya_teknisi", createFormatString(biayaTeknis))
        map.put("biaya_beli_perangkat   ", createFormatString(biayaBeliPerangkat))
        map.put("biaya_perbaikan_perangkat", createFormatString(biayaPerbaikanPerangkat))
        map.put("site_donor", createFormatString(sitDonor))
        map.put("site_receipter", createFormatString(siteReceipter))
        map.put("dana_operasional", createFormatString(danaOprasional))
        map.put("biaya_tukang", createFormatString(biayaTukang))
        map.put("user_id", createFormatString(userId))

        var file1: File? = null
        var file2: File? = null
        var file3: File? = null
        var file4: File? = null
        var gmbr1: MultipartBody.Part? = null
        var gmbr2: MultipartBody.Part? = null
        var gmbr3: MultipartBody.Part? = null
        var gmbr4: MultipartBody.Part? = null

        if (img1.isNotEmpty()){
            if (bitmap1 == null){
                file1 = null
                gmbr1 = null
            }else{
                file1 = createTempFile(bitmap1!!)
                val reqFile1 = RequestBody.create(MediaType.parse("image/*"), file1)
                gmbr1 = MultipartBody.Part.createFormData("gbr_sblm", file1.name, reqFile1)
            }
        }
        if(img2.isNotEmpty()){
            if (bitmap2 == null){
                file2 = null
                gmbr2 = null
            }else{
                file2 = createTempFile(bitmap2!!)
                val reqFile2 = RequestBody.create(MediaType.parse("image/*"), file2)
                gmbr2 = MultipartBody.Part.createFormData("gbr_sdh", file2.name, reqFile2)
            }
        }
        if(img3.isNotEmpty()){
            if (bitmap3 == null){
                file3 = null
                gmbr3 = null
            }else{
                file3 = createTempFile(bitmap3!!)
                val reqFile3 = RequestBody.create(MediaType.parse("image/*"), file3)
                gmbr3 = MultipartBody.Part.createFormData("gbr_bon", file3.name, reqFile3)
            }
        }
        if(img4.isNotEmpty()){
            if (bitmap4 == null){
                file4 = null
                gmbr4 = null
            }else{
                file4 = createTempFile(bitmap4!!)
                val reqFile4 = RequestBody.create(MediaType.parse("image/*"), file4)
                gmbr4 = MultipartBody.Part.createFormData("gbr_lapangan", file4.name, reqFile4)
            }
        }

        RetrofitClient.apiInstance.addBiayaLapangan(gmbr1, gmbr2, gmbr3, gmbr4, map)
            .enqueue(object : Callback<BiayaLapanganResponse> {
                override fun onResponse(
                    call: Call<BiayaLapanganResponse>,
                    response: Response<BiayaLapanganResponse>
                ) {
                    if(response.isSuccessful){
                        Toast.makeText(getApplicationContext(), response.body()?.message, Toast.LENGTH_LONG).show()
                        val intent = Intent(this@Keuangan, MainActivity::class.java)
                        startActivity(intent)
                        finish()
                        binding.btnKirim.revertAnimation()
                    }else{
                        Toast.makeText(getApplicationContext(), response.message() ,
                            Toast.LENGTH_LONG).show()
                        binding.btnKirim.revertAnimation()
                    }

                }

                override fun onFailure(call: Call<BiayaLapanganResponse>, t: Throwable) {
                    t.message?.let { Log.d("error Server", it) }
                    binding.btnKirim.revertAnimation()
                }

            })

    }

    fun BitMapToString(userImage1: Bitmap): String? {
        val baos = ByteArrayOutputStream()
        userImage1.compress(Bitmap.CompressFormat.PNG, 60, baos)
        val b = baos.toByteArray()
        Document_img1 = Base64.encodeToString(b, Base64.DEFAULT)
        return Document_img1
    }
    fun getResizedBitmap(image: Bitmap, maxSize: Int): Bitmap {
        var width = image.width
        var height = image.height
        val bitmapRatio = width.toFloat() / height.toFloat()
        if (bitmapRatio > 1) {
            width = maxSize
            height = (width / bitmapRatio).toInt()
        } else {
            height = maxSize
            width = (height * bitmapRatio).toInt()
        }
        return Bitmap.createScaledBitmap(image, width, height, true)
    }


    fun createTempFile(bitmap: Bitmap): File {
        var file  = File(getExternalFilesDir(Environment.DIRECTORY_PICTURES),
            System.currentTimeMillis().toString()+"_image.PNG")
        var bos = ByteArrayOutputStream()

        bitmap.compress(Bitmap.CompressFormat.PNG,0, bos)
        var bitmapData = bos.toByteArray()

        try {
            var fos =  FileOutputStream(file)
            fos.write(bitmapData)
            fos.flush()
            fos.close()
        } catch (e: IOException) {
            e.printStackTrace()
        }
        return file;

        println(file.toString())
    }

    @NonNull
    fun createFormatString(descriptionString:String): RequestBody {
        return RequestBody.create(
            MultipartBody.FORM, descriptionString);
    }

    fun String.toEditable(): Editable =  Editable.Factory.getInstance().newEditable(this)

    override fun onSupportNavigateUp():Boolean{
        onBackPressed()
        return true
    }

}
