package com.sibatel.solarapp.ui.mentoring.solar.penggunaan

import android.R
import android.app.DatePickerDialog
import android.content.Intent
import android.graphics.Bitmap
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.*
import androidx.appcompat.app.AppCompatActivity
import com.sibatel.solarapp.data.model.mobil.MobilResponse
import com.sibatel.solarapp.data.model.solar.penggunaansolar.PenggunaanSolarResponse
import com.sibatel.solarapp.data.model.tower.TowerResponse
import com.sibatel.solarapp.databinding.ActivityPenggunaanSolarBinding
import com.sibatel.solarapp.network.ApiServices
import com.sibatel.solarapp.network.RetrofitClient
import com.sibatel.solarapp.ui.mentoring.MentoringSolar
import com.sibatel.solarapp.utils.SharedPref
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.util.*

class MenuPenggunaanSolar : AppCompatActivity() {
    private lateinit var binding : ActivityPenggunaanSolarBinding
    private lateinit var site: Spinner
    private lateinit var sharedPref: SharedPref
    var tanggal = ""
    var tujuanSite = ""

    override fun onCreate(savedInstanceState: Bundle?){
        super.onCreate(savedInstanceState)
        binding = ActivityPenggunaanSolarBinding.inflate(layoutInflater)
        supportActionBar?.elevation = 0f
        supportActionBar?.setDisplayHomeAsUpEnabled(true)
        setContentView(binding.root)
        supportActionBar?.title = "Penggunaan Solar"
        supportActionBar?.setDisplayShowHomeEnabled(true)
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        sharedPref = SharedPref(this)

        site = binding.site



        binding.btnBatalkanOrderan.setOnClickListener{
            RetrofitClient.apiInstance.batalkanPesanan(sharedPref.getId().toString())
                .enqueue(object : Callback<MobilResponse>{
                    override fun onResponse(
                        call: Call<MobilResponse>,
                        response: Response<MobilResponse>
                    ) {
                        val intent = Intent(this@MenuPenggunaanSolar, MentoringSolar::class.java)
                        Toast.makeText(this@MenuPenggunaanSolar, "Sukses membatalkan orderan", Toast.LENGTH_LONG).show()
                        startActivity(intent)
                        finish()
                    }

                    override fun onFailure(call: Call<MobilResponse>, t: Throwable) {
                        t.message?.let { Log.d("error Server", it) }
                    }

                })
        }


        binding.dateSolarTaken.setOnClickListener {
            val cldr: Calendar = Calendar.getInstance()
            val day: Int = cldr.get(Calendar.DAY_OF_MONTH)
            val month: Int = cldr.get(Calendar.MONTH)
            val year: Int = cldr.get(Calendar.YEAR)
            var bulan = ""
            var hari = ""

            val picker = DatePickerDialog(
                this,
                DatePickerDialog.OnDateSetListener { view, year, monthOfYear, dayOfMonth ->
                    if(monthOfYear + 1<10){
                        bulan = "0"+(monthOfYear + 1)
                    }else{
                        bulan = (monthOfYear + 1).toString()
                    }

                    if(dayOfMonth<10){
                        hari = "0"+dayOfMonth
                    }else{
                        hari = dayOfMonth.toString()
                    }
                    binding.dateSolarTaken.setText(
                        year.toString() + "-" + bulan + "-" + hari
                    )
                    tanggal = binding.dateSolarTaken.text.toString()
                },
                year,
                month,
                day
            )
            picker.show()
        }

        var allTower = ArrayList<String>()
        allTower.add("Pilih Site")

        RetrofitClient.apiInstance.getAllTower().enqueue(object : Callback<TowerResponse> {
            override fun onResponse(call: Call<TowerResponse>, response: Response<TowerResponse>) {
                if (response.isSuccessful){
                    response.body()?.result?.forEach {
                        if(it?.clusterTower.equals(sharedPref.getSite1())){
                            it?.namaTower?.let { it1 -> allTower.add(it1) }
                        }
                    }
                }
            }

            override fun onFailure(call: Call<TowerResponse>, t: Throwable) {

            }

        })
        val adapter = ArrayAdapter<String>(this, R.layout.simple_spinner_dropdown_item, allTower)
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        site.adapter = adapter


        RetrofitClient.apiInstance.cekPenggunaanSolar(sharedPref.getId())
            .enqueue(object : Callback<PenggunaanSolarResponse>{
                override fun onResponse(
                    call: Call<PenggunaanSolarResponse>,
                    response: Response<PenggunaanSolarResponse>
                ) {
                    if (response.isSuccessful){
                        if (response?.body()?.result?.size!! >0){
                            binding.btnKrim.visibility = View.GONE
                            binding.layoutEdit.visibility = View.VISIBLE
                            binding.dateSolarTaken.setText(response?.body()?.result?.get(0)?.tanggal)
                            tanggal = response?.body()?.result?.get(0)?.tanggal!!
                            tujuanSite = response?.body()?.result?.get(0)?.tujuanSite!!
                            site.setSelection(allTower.indexOf(response?.body()?.result?.get(0)?.tujuanSite!!))
                        }else{
                            binding.layoutEdit.visibility = View.GONE
                            binding.btnKrim.visibility = View.VISIBLE
                        }
                    }
                }

                override fun onFailure(call: Call<PenggunaanSolarResponse>, t: Throwable) {
                    t.message?.let { Log.d("error Server", it) }
                }

            })

        site.onItemSelectedListener = object : AdapterView.OnItemSelectedListener{
            override fun onItemSelected(p0: AdapterView<*>?, p1: View?, p2: Int, p3: Long) {
                if (p2 == 0){
                    if (tujuanSite.isNotEmpty()){
                        (p1 as TextView).setText(tujuanSite)
                    }else{
                        tujuanSite = ""
                    }

                }else{
                    val number = p0?.getItemAtPosition(p2).toString()
                    tujuanSite = number
                }
            }

            override fun onNothingSelected(p0: AdapterView<*>?) {

            }

        }

        binding.btnSimpanPerubahan.setOnClickListener{
            val intent = Intent(this, LaporanPengisianSolar::class.java)
            RetrofitClient.apiInstance.updatePenggunaanSolar(sharedPref.getId().toString(),tanggal, tujuanSite)
                .enqueue(object : Callback<PenggunaanSolarResponse>{
                    override fun onResponse(
                        call: Call<PenggunaanSolarResponse>,
                        response: Response<PenggunaanSolarResponse>
                    ) {
                        intent.putExtra("tanggal", tanggal)
                        intent.putExtra("tujuanSite", tujuanSite)
                        startActivity(intent)
                        finish()
                    }

                    override fun onFailure(call: Call<PenggunaanSolarResponse>, t: Throwable) {
                        t.message?.let { Log.d("error Server", it) }
                    }

                })

        }

        binding.btnKrim.setOnClickListener{
                if (tanggal.isEmpty()){
                    binding.dateSolarTaken.error = "Pilih tanggal terlebih dahulu"
                }else if(tujuanSite.isEmpty()){
                    (site.selectedView as TextView).error = "Anda harus memilih Site terlebih dahulu"
                }else{
                    RetrofitClient.apiInstance.orderMobil(sharedPref.getId().toString(), tanggal, tujuanSite)
                        .enqueue(object : Callback<MobilResponse>{
                            override fun onResponse(
                                call: Call<MobilResponse>,
                                response: Response<MobilResponse>
                            ) {
                                Toast.makeText(this@MenuPenggunaanSolar, "Sukses menambah orderan", Toast.LENGTH_LONG).show()
                                val intent = Intent(this@MenuPenggunaanSolar, LaporanPengisianSolar::class.java)
                                intent.putExtra("tanggal", tanggal)
                                intent.putExtra("tujuanSite", tujuanSite)
                                startActivity(intent)
                                finish()
                            }

                            override fun onFailure(call: Call<MobilResponse>, t: Throwable) {
                                t.message?.let { Log.d("error Server", it) }
                            }

                        })

                }
        }
    }

    override fun onSupportNavigateUp():Boolean{
        onBackPressed()
        return true
    }
}