package com.sibatel.solarapp.ui.mobil

import android.os.Bundle
import android.os.PersistableBundle
import androidx.annotation.StringRes
import androidx.appcompat.app.AppCompatActivity
import com.google.android.material.tabs.TabLayoutMediator
import com.sibatel.solarapp.R
import com.sibatel.solarapp.databinding.ActivityDataMobilBinding
import com.sibatel.solarapp.ui.mentoring.MentoringSolar

class DataMobil  : AppCompatActivity() {
    private lateinit var binding: ActivityDataMobilBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityDataMobilBinding.inflate(layoutInflater)
        setContentView(binding.root)

        supportActionBar?.elevation = 0f
        supportActionBar?.setDisplayHomeAsUpEnabled(true)
        supportActionBar?.title = "Mobil"

        val sectionPagerAdapter = DataMobilePagerAdapter(this)
        binding.viewPager.adapter = sectionPagerAdapter

        val tabLayout = binding.tabs

        TabLayoutMediator(tabLayout, binding.viewPager){tab, position ->
            tab.text =  resources.getString(DataMobil.TAB_TITLES[position])
        }.attach()
    }

    companion object{
        @StringRes
        private val TAB_TITLES = intArrayOf(R.string.SCD, R.string.Koordinator, R.string.CGL, R.string.Koerktif, R.string.Maintenance, R.string.Project)
    }

    override fun onSupportNavigateUp():Boolean{
        onBackPressed()
        return true
    }
}